require 'api-resource'
require_relative 'affiliation-api/resource'

module AffiliationApi
  autoload :Category, 'affiliation-api/category'
  autoload :Merchant, 'affiliation-api/merchant'
  autoload :Ad, 'affiliation-api/ad'
  autoload :Offer, 'affiliation-api/offer'
  autoload :Program, 'affiliation-api/program'
  autoload :MerchantVersion, 'affiliation-api/merchant_version'
  autoload :Sale, 'affiliation-api/sale'
  autoload :Client, 'affiliation-api/client'

  def self.setup(api_key, api_secret, api_endpoint='https://affiliation.api.wizypay.com')
    AffiliationApi::Resource::base_url = api_endpoint
    AffiliationApi::Resource::with_hmac(api_key, api_secret)
  end
end
