module AffiliationApi
  class Program < AffiliationApi::Resource
    attr_accessor :id,
                  :name,
                  :description,
                  :url,
                  :image,
                  :image_url,
                  :hidden,
                  :network_name,
                  :ad_space_name,
                  :network_status,
                  :network_updated_at,
                  :network_data,
                  :needs_review,
                  :categories,
                  :category_ids,
                  :reward_percentage,
                  :reward_fixed,
                  :reward_details,
                  :primary_ad,
                  :primary_ad_id,
                  :ads

    def network_updated_at
      return nil unless @network_updated_at.present?
      Time.parse(@network_updated_at)
    end

    def categories
      @categories['data'].map do |cat_data|
        Category.new cat_data
      end
    end

    def primary_ad
      Ad.new @primary_ad['data']
    end

    def ads
      @ads['data'].map do |ad_data|
        Ad.new ad_data
      end
    end

    def primary_ad_id
      @primary_ad_id || primary_ad.id || ads.first.try(:id)
    end
  end
end
